/*******************************************************************************
DeskCalc. Copyright 1997-2000 Wunderbear Software. See below for license info.
$Id: CalcWindow.h,v 1.5 1998/12/03 08:29:39 timmy Exp $
Code Classification: C++, BeOS

This component implements the calculator window class, which contains the core
application interface, and is archived to store the state of the app.

Copyright (c) 1997-2000 Wunderbear Software. All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

1) Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

2) Redistributions in binary form must reproduce the above copyright notice,
this list of conditions and the following disclaimer in the documentation and/or
other materials provided with the distribution.

3) Neither the name of the Wunderbear Software nor the names of its contributors
may be used to endorse or promote products derived from this software without
specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COMPANY OR CONTRIBUTORS BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*******************************************************************************/


#ifndef _CALC_WINDOW_H
#define _CALC_WINDOW_H


// BeOS Includes

#ifndef _RECT_H
	#include <interface/Rect.h>
#endif

#ifndef _WINDOW_H
	#include <interface/Window.h>
#endif


// Class Definitions

class BMenuItem;
class BPopUpMenu;
class BDragger;

class CalcView;

_EXPORT class CalcWindow : public BWindow {

	public:
		
		// ****** STATICS ******
		
		static CalcWindow *Instantiate(BMessage *archive);
		
		
		// ****** CREATORS ******
		
		// Constructor.
		CalcWindow(BRect frame, const char *title, const char *calcDesc);

		// Construct from archive.
		CalcWindow(BMessage *archive);

		// Destructor.
		virtual ~CalcWindow();
		
		
		// ****** MANIPULATORS ******
		
		// Message received hook.
		virtual void MessageReceived(BMessage *message);
		
		// Quit requested hook.
		virtual bool QuitRequested();
		
		// Window dimensions changed hook.
		virtual void FrameResized(float width, float height);

		
		// ****** ACCESSORS ******
		
		// Archive this window.
		virtual status_t Archive(BMessage *archive, bool deep = true) const;

	
	private:
	
		BDragger *mDragger;		// Replicant parent view.
		CalcView *mCalcView;	// Main calculator view.
			
}; // end class CalcWindow


/******************************************************************************/

#endif // _CALC_WINDOW_H

// end CalcWindow.h
